import java.io.*;

class Pulse
{
  public static void main(String [] args)
  {
    final int BASSDRUM = 35;
    final int SNARE = 38;
    final int CLOSEDHIHAT = 42;
    final int OPENHIHAT = 46;

    MidiWrapper midi = new MidiWrapper();
    midi.setMidiChannel(9);

    double bpm=120; // Beat Per Minute : quarter notes per minute
    int quarterNoteInterval = (int)(60000/bpm); // milliseconds

    if(args.length < 1)
    {
      System.out.println("Enter a number and -optionally- the BPM");
      System.exit(0);
    }


    if(args.length > 1)
    {
      bpm = Integer.valueOf(args[1]);
      quarterNoteInterval = (int)(60000/bpm); // milliseconds
    }

    switch(Integer.valueOf(args[0]) )
    {
      case 1: // hi-hat pulse
        while(bpm > 0)
        {
          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval);
        } // while
      break;

      case 2: // hi-hat pulse + kick + snare
        while(bpm > 0)
        {
          midi.playNote(CLOSEDHIHAT,100);
          midi.playNote(BASSDRUM,100);
          midi.pause(quarterNoteInterval);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval);

          midi.playNote(CLOSEDHIHAT,100);
          midi.playNote(SNARE,100);
          midi.pause(quarterNoteInterval);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval);
        } // while
      break;

      case 3: // hi-hat double pulse + kick + snare
        while(bpm > 0)
        {
          midi.playNote(CLOSEDHIHAT,100);
          midi.playNote(BASSDRUM,100);
          midi.pause(quarterNoteInterval/2);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval/2);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval/2);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval/2);

          midi.playNote(CLOSEDHIHAT,100);
          midi.playNote(SNARE,100);
          midi.pause(quarterNoteInterval/2);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval/2);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval/2);

          midi.playNote(CLOSEDHIHAT,100);
          midi.pause(quarterNoteInterval/2);
        } // while
      break;

      case 4: // hi-hat pulse
        while(bpm > 0)
	{
	  midi.playNote(CLOSEDHIHAT,100);
          midi.playNote(BASSDRUM,100);
          midi.pause(quarterNoteInterval);

          midi.playNote(CLOSEDHIHAT,100);
          midi.playNote(SNARE,100);

          midi.pause(3*quarterNoteInterval/4);
          midi.playNote(SNARE,100);
          midi.pause(quarterNoteInterval/4);

          midi.playNote(CLOSEDHIHAT,100);
          midi.playNote(BASSDRUM,100);

          midi.pause(quarterNoteInterval/4);
          midi.playNote(SNARE,100);
          midi.pause(quarterNoteInterval/4);

          midi.playNote(BASSDRUM,100);
          midi.pause(quarterNoteInterval/2);

          midi.playNote(CLOSEDHIHAT,100);
          midi.playNote(SNARE,100);
          midi.pause(quarterNoteInterval);
        } // while
      break;
    } // switch

  } // main()
} // Pulse{}
