import java.util.ArrayList;
import java.util.Collections;


class Scheduler
{
  public static void main(String [] args)
  {
    final int BASSDRUM = 35;
    final int SNARE = 38;
    final int CLOSEDHIHAT = 42;
    final int OPENHIHAT = 46;
    final int ENDOFSEQUENCE = 0;

    long timeZero;
    long ts=0;

    MidiWrapper midi = new MidiWrapper();
    midi.setMidiChannel(9); // Drum track

    double bpm=120; // quarter notes per minute
    int quarterNoteInterval = (int)(60000/bpm); // milliseconds

    ArrayList<RhythmEvent> sequence = new ArrayList<RhythmEvent>();

    /*
     * Construct a sequence of events
     *
     * You can add events at random. Before playing they are sorted
     *  based on their time stamps
     */
    sequence.add(new RhythmEvent(CLOSEDHIHAT,0) );
    sequence.add(new RhythmEvent(BASSDRUM,0) );

    sequence.add(new RhythmEvent(CLOSEDHIHAT,quarterNoteInterval) );
    sequence.add(new RhythmEvent(SNARE,quarterNoteInterval) );

    sequence.add(new RhythmEvent(SNARE,7*quarterNoteInterval/4) );

    sequence.add(new RhythmEvent(CLOSEDHIHAT,2*quarterNoteInterval) );
    sequence.add(new RhythmEvent(BASSDRUM,2*quarterNoteInterval) );

    sequence.add(new RhythmEvent(SNARE,9*quarterNoteInterval/4) );
    sequence.add(new RhythmEvent(BASSDRUM,10*quarterNoteInterval/4) );

    sequence.add(new RhythmEvent(CLOSEDHIHAT,3*quarterNoteInterval) );
    sequence.add(new RhythmEvent(SNARE,3*quarterNoteInterval) );

    sequence.add(new RhythmEvent(ENDOFSEQUENCE,4*quarterNoteInterval) );

    /* double pulse
    sequence.add(new RhythmEvent(CLOSEDHIHAT,quarterNoteInterval/2) );
    sequence.add(new RhythmEvent(CLOSEDHIHAT,3*quarterNoteInterval/2) );
    sequence.add(new RhythmEvent(CLOSEDHIHAT,5*quarterNoteInterval/2) );
    sequence.add(new RhythmEvent(CLOSEDHIHAT,7*quarterNoteInterval/2) );
    */

    Collections.sort(sequence); // Order by timestamp


    // Play the sequence repeatedly
    while(true)
    {
      timeZero = System.currentTimeMillis();
      ts=0;

      for(int i=0; i<sequence.size(); i++)
      {
        ts = sequence.get(i).getTimestamp();
        while(System.currentTimeMillis() - timeZero < ts)
	{
          midi.pause(5);
        }

        if(sequence.get(i).getNote() > 0)
	{
          midi.playNote(sequence.get(i).getNote(),100);
	}
	else System.out.println("LOOP END");
      } // for
    } // while

  } // main()
} // Scheduler{}
